=== debian/changelog ===
volk (2.4.1-2) unstable; urgency=medium

  [ Shengjing Zhu ]
  * Use system cpu_features package

  [ A. Maitland Bottoms ]
  * Adopt Use system cpu_features package patch (Closes: #978096)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 27 Dec 2020 15:16:07 -0500

volk (2.4.1-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 17 Dec 2020 23:53:21 -0500

volk (2.4.0-4) unstable; urgency=medium

  * skip cpu_features on "Unsupported OS" kFreeBSD
  * bump Standards-Version - no other changes.

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 15 Dec 2020 19:53:16 -0500

volk (2.4.0-3) unstable; urgency=medium

  * Fix binary-indep build (Closes: #976300)
  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 03 Dec 2020 20:43:29 -0500

volk (2.4.0-2) experimental; urgency=medium

  * Make use of cpu_features a CMake option with sensible defaults per arch

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 30 Nov 2020 16:19:19 -0500

volk (2.4.0-1) experimental; urgency=medium

  * New upstream release
  * cpu_features git submodule packaged as cpu-features source component.
  * Upload to experimental for soversion bump

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 22 Nov 2020 12:35:43 -0500
