## volk 2.5.0

=== debian/changelog ===
volk (2.5.0-1) experimental; urgency=medium

  * New upstream release
  * Use libcpu-features-dev on powerpc and x32 (Closes: #978602)
  * Mention volk-config-info and volk_modtool in description (Closes: #989263)
  * Upload to experimental for soversion bump

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 10 Jun 2021 18:29:47 -0400
