=== debian/changelog ===
volk (2.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 13 Feb 2022 00:18:58 -0500

volk (2.5.0-2) unstable; urgency=medium

  * upload to unstable
  * with some upstream bugfixes

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 21 Oct 2021 23:30:05 -0400
