=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                debhelper-compat (= 13),
                dh-python,
                liborc-0.4-dev,
-               libcpu-features-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el],
+               libcpu-features-dev [amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el x32],
 	       python3-dev,
 	       python3-mako
 Build-Depends-Indep: doxygen, graphviz
@@ -16,7 +16,7 @@
 Vcs-Browser: https://salsa.debian.org/bottoms/pkg-volk
 Vcs-Git: https://salsa.debian.org/bottoms/pkg-volk.git
 
-Package: libvolk2.4
+Package: libvolk2.5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -33,7 +33,7 @@
 Package: libvolk2-dev
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk2.4 (=${binary:Version}), ${misc:Depends}
+Depends: libvolk2.5 (=${binary:Version}), ${misc:Depends}
 Breaks: gnuradio-dev (<<3.7.8), libvolk-dev, libvolk1.0-dev, libvolk1-dev
 Replaces: gnuradio-dev (<<3.7.8), libvolk-dev, libvolk1.0-dev, libvolk1-dev
 Suggests: libvolk2-doc
@@ -51,7 +51,7 @@
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk2.4 (=${binary:Version}),
+Depends: libvolk2.5 (=${binary:Version}),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
@@ -63,7 +63,9 @@
  very powerful vector operations that can give signal processing a
  huge boost in performance.
  .
- This package includes the volk_profile tool.
+ This package includes: the volk_profile tool to customize settings for
+ the system; volk_modtool to create new optimized modules; and
+ volk-config-info to show settings.
 
 Package: libvolk2-doc
 Section: doc
